// ======================================================================
//
// DebugPrint.cpp
// jeff grills
//
// copyright 1995 origin systems inc
//
// ======================================================================

#include "First.h"

#if USE_DEBUG_PRINT

#include "DebugPrint.h"
#include "Os.h"

#include <stdarg.h>

// ======================================================================
// global variables

static bool  DoNotUseDPrintFlagArray[3+DP_CNT];
bool        *DoNotUseDPrintLogging         = DoNotUseDPrintFlagArray+0;
bool        *DoNotUseDPrintExplicitLogging = DoNotUseDPrintFlagArray+1;
bool        *DoNotUseDPrintPaused          = DoNotUseDPrintFlagArray+2;
bool        *DoNotUseDPrintFlag            = DoNotUseDPrintFlagArray+3;

// ======================================================================

void DoNotUseDPrintClear(void)
{
	if (!*DoNotUseDPrintPaused)
		Os::report(Os::ReportClear, NULL, NULL);
}

// ----------------------------------------------------------------------

void DoNotUseDPrint(const char *fmt, ...)
{
	bool logging;

	logging = *DoNotUseDPrintExplicitLogging | *DoNotUseDPrintLogging;
	*DoNotUseDPrintExplicitLogging = false;

	// if we are logging or not paused
	if (fmt && (logging || !*DoNotUseDPrintPaused))
	{
		va_list va;

		va_start(va, fmt);
		Os::vreport(logging ? Os::ReportLog : 0, NULL, fmt, va);
		va_end(va);
	}
}

// ======================================================================

#endif
